## ardour 5.12.0

=== wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import string
import subprocess
import sys
import platform as PLATFORM
from waflib.Tools import winres
from waflib.Build import Context
from waflib.Build import BuildContext

class i18n(BuildContext):
        cmd = 'i18n'
        fun = 'i18n'

class i18n_pot(BuildContext):
        cmd = 'i18n_pot'
        fun = 'i18n_pot'

class i18n_po(BuildContext):
        cmd = 'i18n_po'
        fun = 'i18n_po'

class i18n_mo(BuildContext):
        cmd = 'i18n_mo'
        fun = 'i18n_mo'

def is_tracks_build(self, *k, **kw):
        return self.env['PROGRAM_NAME'] == 'Tracks Live'

Context.Context.is_tracks_build = is_tracks_build

compiler_flags_dictionaries= {
    'gcc' : {
        # Flags required when building a debug build
        'debuggable' : [ '-g' ],
        # Flags required for the linker (if any) when building a debug build
        'linker-debuggable' : '',
        # Flags required when building a non-debug optimized build
        'nondebuggable' : '-DNDEBUG',
        # Flags required to enable profiling at runtime with optimized builds
        'profile' : [ '-fno-omit-frame-pointer' ],
        # Flags required to enable gprofile profiling
        'gprofile' : '-pg',
        # Flags required to disable warnings about unused arguments to function calls
        'silence-unused-arguments' : '',
        # Flags required to use SSE unit for general math
        'sse' : '-msse',
        # Flags required to use SSE unit for floating point math
        'fpmath-sse' : '-mfpmath=sse',
        # Flags required to use XMM Intrinsics
        'xmmintrinsics' : '-DUSE_XMMINTRIN',
        # Flags to use posix pipes between compiler stages
        'pipe' : '-pipe',
        # Flags for maximally optimized build
        'full-optimization' : [ '-O3', '-fomit-frame-pointer', '-ffast-math', '-fstrength-reduce', ],
        # Flag to ensure that compiler error output includes column/line numbers
        'show-column' : '-fshow-column',
        # Flags required to build for x86 only (OS X feature)
        'generic-x86' : '',
        # Flags required to build for PowerPC only (OS X feature)
        'generic-ppc' : '',
        # All flags required to get basic warnings to be generated by the compiler
        'basic-warnings' : [ '-Wall', '-Wpointer-arith', '-Wcast-qual', '-Wcast-align', '-Wno-unused-parameter' ],
        # Any additional flags for warnings that are specific to C (not C++)
        'extra-c-warnings' : [ '-Wstrict-prototypes', '-Wmissing-prototypes' ],
        # Any additional flags for warnings that are specific to C++ (not C)
        'extra-cxx-warnings' : [ '-Woverloaded-virtual', '-Wno-unused-local-typedefs' ],
        # Flags used for "strict" compilation, C and C++ (i.e. compiler will warn about language issues)
        'strict' : ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings', '-Wunsafe-loop-optimizations', '-Wlogical-op' ],
        # Flags used for "strict" compilation, C only (i.e. compiler will warn about language issues)
        'c-strict' : ['-std=c99', '-pedantic', '-Wshadow'],
        # Flags used for "strict" compilation, C++ only (i.e. compiler will warn about language issues)
        'cxx-strict' : [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', '-fstrict-overflow' ],
        # Flags required for whatever consider the strictest possible compilation
        'ultra-strict' : ['-Wredundant-decls', '-Wstrict-prototypes', '-Wmissing-prototypes'],
        # Flag to turn on C99 compliance by itself
        'c99': '-std=c99',
        # Flag to enable AT&T assembler syntax
        'attasm': '-masm=att',
        # Flags to make AVX instructions/intrinsics available
        'avx': '-mavx',
        # Flags to generate position independent code, when needed to build a shared object
        'pic': '-fPIC',
        # Flags required to compile C code with anonymous unions (only part of C11)
        'c-anonymous-union': '-fms-extensions',
    },
    'msvc' : {
        'debuggable' : ['/DDEBUG', '/Od', '/Zi', '/MDd', '/Gd', '/EHsc'],
        'linker-debuggable' : ['/DEBUG', '/INCREMENTAL' ],
        'nondebuggable' : ['/DNDEBUG', '/Ob1', '/MD', '/Gd', '/EHsc'],
        'profile' : '/Oy-',
        'sse' : '/arch:SSE',
        'silence-unused-arguments' : '',
        'sse' : '',
        'fpmath-sse' : '',
        'xmmintrinsics' : '',
        'pipe' : '',
        'full-optimization' : '/O2',
        'no-frame-pointer' : '',
        'fast-math' : '',
        'strength-reduce' : '',
        'show-column' : '',
        'generic-x86' : '',
        'generic-ppc' : '',
        'basic-warnings' : '',
        'extra-c-warnings' : '',
        'extra-cxx-warnings' : '',
        'ultra-strict' : '',
        'c-strict' : '',
        'cxx-strict' : '',
        'strict' : '',
        'c99': '/TP',
        'attasm': '',
        'avx': '',
        'pic': '',
        'c-anonymous-union': '',
    },
}

# Copy, edit and insert variants on gcc dict for gcc-darwin and clang

gcc_darwin_dict = compiler_flags_dictionaries['gcc'].copy()
gcc_darwin_dict['extra-cxx-warnings'] = [ '-Woverloaded-virtual' ]
gcc_darwin_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual' ]
gcc_darwin_dict['strict'] = ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings' ]
gcc_darwin_dict['generic-x86'] = [ '-arch', 'i386' ]
gcc_darwin_dict['generic-ppc'] = [ '-arch', 'ppc' ]
compiler_flags_dictionaries['gcc-darwin'] = gcc_darwin_dict;

clang_dict = compiler_flags_dictionaries['gcc'].copy();
clang_dict['sse'] = ''
clang_dict['fpmath-sse'] = ''
clang_dict['xmmintrinsics'] = ''
clang_dict['silence-unused-arguments'] = '-Qunused-arguments'
clang_dict['extra-cxx-warnings'] = [ '-Woverloaded-virtual', '-Wno-mismatched-tags', '-Wno-cast-align', '-Wno-unused-local-typedefs' ]
clang_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', '-fstrict-overflow' ]
clang_dict['strict'] = ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings' ]
clang_dict['generic-x86'] = [ '-arch', 'i386' ]
clang_dict['full-optimization'] = [ '-O3', '-fomit-frame-pointer', '-ffast-math', ]
compiler_flags_dictionaries['clang'] = clang_dict;

clang_darwin_dict = compiler_flags_dictionaries['clang'].copy();
clang_darwin_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', ]
clang_darwin_dict['full-optimization'] = [ '-O3', '-ffast-math']
compiler_flags_dictionaries['clang-darwin'] = clang_darwin_dict;

def fetch_git_revision ():
    cmd = "git describe HEAD | sed 's/^[A-Za-z0-9]*+//'"
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    rev = output[0].decode ('utf-8')
    return rev

def fetch_tarball_revision ():
    if not os.path.exists ('libs/ardour/revision.cc'):
        print ('This tarball was not created correctly - it is missing libs/ardour/revision.cc')
        sys.exit (1)
    with open('libs/ardour/revision.cc', 'rb') as f:
        content = f.readlines()
        remove_punctuation_map = dict((ord(char), None) for char in '";')
        return content[1].decode('utf-8').strip().split(' ')[7].translate (remove_punctuation_map)

if os.path.isdir (os.path.join(os.getcwd(), '.git')):
    rev = fetch_git_revision ()
else:
    rev = fetch_tarball_revision ()

#
# rev is now of the form MAJOR.MINOR[-rcX]-rev-commit
# or, if right at the same rev as a release, MAJOR.MINOR[-rcX]
#

parts = rev.split ('.', 1)
MAJOR = parts[0]
other = parts[1].split('-', 1)
MINOR = other[0]
if len(other) > 1:
    MICRO = other[1].rsplit('-',1)[0].replace('-','.')
else:
    MICRO = '0'

V = MAJOR + '.' + MINOR + '.' + MICRO

def sanitize(s):
    # round-trip to remove anything in the string that is not encodable in
    # ASCII, yet still keep a real (utf8-encoded internally) string.
    s = s.encode ('ascii', 'ignore').decode ("utf-8")
    # In Python3, bytes is the class of binary content and encode() returns
    # bytes to transform a string according to a text encoding; str is the
    # class of normal strings (utf8-encoded internally) and decode() returns
    # that type.
    # Python 2 did not initially cater for encoding problems and can use str
    # for both binary content and for (decoded) strings. The Unicode type was
    # added to correspond to Python 3 str, and the Python 2 str type should
    # only correspond to bytes. Alas, almost everything in the Python 2
    # ecosystem has been written with str in mind and doesn't handle Unicode
    # objects correctly. If Python 2 is in use, s will be a Unicode object and
    # to avoid strange problems later we convert back to str, but in utf-8
    # nonetheless.
    if not isinstance(s, str):
        s = s.encode("utf-8")
    return s
VERSION = sanitize(V)
PROGRAM_VERSION = sanitize(MAJOR)
del sanitize

if len (sys.argv) > 1 and sys.argv[1] == 'dist':
        if not 'APPNAME' in os.environ:
                print ("You must define APPNAME in the environment when running ./waf dist")
                sys.exit (1)
        APPNAME = os.environ['APPNAME'];

# Mandatory variables
top = '.'
out = 'build'

children = [
        # optionally external libraries
        'libs/fluidsynth',
        'libs/hidapi',
        'libs/libltc',
        'libs/lua',
        'libs/ptformat',
        'libs/qm-dsp',
        'libs/vamp-plugins',
        # core ardour libraries
        'libs/pbd',
        'libs/midi++2',
        'libs/evoral',
        'libs/surfaces',
        'libs/panners',
        'libs/backends',
        'libs/timecode',
        'libs/ardour',
        'libs/gtkmm2ext',
        'libs/audiographer',
        'libs/canvas',
        'libs/widgets',
        'libs/waveview',
        'libs/plugins/reasonablesynth.lv2',
        'libs/plugins/a-comp.lv2',
        'libs/plugins/a-delay.lv2',
        'libs/plugins/a-eq.lv2',
        'libs/plugins/a-reverb.lv2',
        'libs/plugins/a-fluidsynth.lv2',
        'gtk2_ardour',
        'export',
        'midi_maps',
        'mcp',
        'osc',
        'patchfiles',
        'scripts',
        'headless',
        'session_utils',
        # shared helper binaries (plugin-scanner, exec-wrapper)
        'libs/fst',
        'libs/vfork',
        'libs/ardouralsautil',
        'tools/luadevel',
]

i18n_children = [
        'gtk2_ardour',
        'libs/ardour',
        'libs/gtkmm2ext',
]

# Version stuff

def fetch_gcc_version (CC):
    cmd = "%s --version" % CC
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    o = output[0].decode('utf-8')
    version = o.split(' ')[2].split('.')
    return version

def create_stored_revision():
    rev = ""
    if os.path.exists('.git'):
        rev = fetch_git_revision();
        print("Git version: " + rev + "\n")
    elif os.path.exists('libs/ardour/revision.cc'):
        print("Using packaged revision")
        return
    else:
        print("Missing libs/ardour/revision.cc.  Blame the packager.")
        sys.exit(-1)

    try:
        #
        # if you change the format of this, be sure to fix fetch_tarball_revision() above
        # so that  it still works.
        #
        text =  '#include "ardour/revision.h"\n'
        text += 'namespace ARDOUR { const char* revision = \"%s\"; }\n' % rev
        print('Writing revision info to libs/ardour/revision.cc using ' + rev)
        o = open('libs/ardour/revision.cc', 'w')
        o.write(text)
        o.close()
    except IOError:
        print('Could not open libs/ardour/revision.cc for writing\n')
        sys.exit(-1)

def get_depstack_rev(depstack_root):
    try:
        with open(depstack_root + '/../.vers', 'r') as f:
            return f.readline()
    except IOError:
        return '-unknown-';

def set_compiler_flags (conf,opt):
    #
    # Compiler flags and other system-dependent stuff
    #
    build_host_supports_sse = False

=== gtk2_ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import shutil
import sys
import re
import time
from waflib.Task import Task
from waflib.Tools import winres
import subprocess
import glob
import copy

# Mandatory variables
top = '.'
out = 'build'

from waflib import TaskGen
@TaskGen.extension('.m')
def m_hook(self, node):
	"""Alias .m files to be compiled the same as .c files, gcc will do the right thing."""
	return self.create_compiled_task('c', node)

path_prefix = 'gtk2_ardour/'

gtk2_ardour_sources = [
        'about.cc',
        'actions.cc',
        'add_route_dialog.cc',
        'ambiguous_file_dialog.cc',
        'analysis_window.cc',
        'ardour_dialog.cc',
        'ardour_http.cc',
        'ardour_ui.cc',
        'ardour_ui2.cc',
        'ardour_ui_dependents.cc',
        'ardour_ui_dialogs.cc',
        'ardour_ui_ed.cc',
        'ardour_ui_mixer.cc',
        'ardour_ui_options.cc',
        'ardour_window.cc',
        'audio_clock.cc',
        'audio_region_editor.cc',
        'audio_region_view.cc',
        'audio_streamview.cc',
        'audio_time_axis.cc',
        'automation_controller.cc',
        'automation_line.cc',
        'automation_region_view.cc',
        'automation_streamview.cc',
        'automation_time_axis.cc',
        'axis_view.cc',
        'big_clock_window.cc',
        'bundle_manager.cc',
        'clock_group.cc',
        'color_theme_manager.cc',
        'configinfo.cc',
        'control_point.cc',
        'control_point_dialog.cc',
        'control_slave_ui.cc',
        'cursor_context.cc',
        'curvetest.cc',
        'debug.cc',
        'duplicate_routes_dialog.cc',
        'edit_note_dialog.cc',
        'editing.cc',
        'editor.cc',
        'editor_actions.cc',
        'editor_audio_import.cc',
        'editor_pt_import.cc',
        'editor_audiotrack.cc',
        'editor_canvas.cc',
        'editor_canvas_events.cc',
        'editor_component.cc',
        'editor_cursors.cc',
        'editor_drag.cc',
        'editor_route_groups.cc',
        'editor_export_audio.cc',
        'editor_group_tabs.cc',
        'editor_keys.cc',
        'editor_locations.cc',
        'editor_markers.cc',
        'editor_mixer.cc',
        'editor_mouse.cc',
        'editor_ops.cc',
        'editor_regions.cc',
        'editor_routes.cc',
        'editor_rulers.cc',
        'editor_selection.cc',
        'editor_snapshots.cc',
        'editor_summary.cc',
        'editor_tempodisplay.cc',
        'editor_timefx.cc',
        'engine_dialog.cc',
        'enums.cc',
        'export_channel_selector.cc',
        'export_dialog.cc',
        'export_file_notebook.cc',
        'export_filename_selector.cc',
        'export_format_dialog.cc',
        'export_format_selector.cc',
        'export_preset_selector.cc',
        'export_report.cc',
        'export_timespan_selector.cc',
        'fft.cc',
        'fft_graph.cc',
        'fft_result.cc',
        'floating_text_entry.cc',
        'sfdb_freesound_mootcher.cc',
        'gain_meter.cc',
        'generic_pluginui.cc',
        'ghostregion.cc',
        'global_port_matrix.cc',
        'group_tabs.cc',
        'gtk_pianokeyboard.c',
        'gui_object.cc',
        'idleometer.cc',
        'insert_remove_time_dialog.cc',
        'instrument_selector.cc',
        'interthread_progress_window.cc',
        'io_selector.cc',
        'hit.cc',
        'keyboard.cc',
        'keyeditor.cc',
        'latency_gui.cc',
        'led.cc',
        'level_meter.cc',
        'location_ui.cc',
        'lua_script_manager.cc',
        'luadialog.cc',
        'luainstance.cc',
        'luawindow.cc',
        'main.cc',
        'main_clock.cc',
        'marker.cc',
        'midi_automation_line.cc',
        'midi_channel_dialog.cc',
        'midi_channel_selector.cc',
        'midi_cut_buffer.cc',
        'midi_export_dialog.cc',
        'midi_list_editor.cc',
        'midi_region_view.cc',
        'midi_scroomer.cc',
        'midi_selection.cc',
        'midi_streamview.cc',
        'midi_time_axis.cc',
        'midi_tracer.cc',
        'midi_velocity_dialog.cc',
        'mini_timeline.cc',
        'missing_file_dialog.cc',
        'missing_plugin_dialog.cc',
        'mixer_group_tabs.cc',
        'mixer_strip.cc',
        'mixer_ui.cc',
        'meterbridge.cc',
        'meter_strip.cc',
        'meter_patterns.cc',
        'monitor_section.cc',
        'monitor_selector.cc',
        'mono_panner.cc',
        'mono_panner_editor.cc',
        'mouse_cursors.cc',
        'nag.cc',
        'new_plugin_preset_dialog.cc',
        'normalize_dialog.cc',
        'note.cc',
        'note_base.cc',
        'note_player.cc',
        'note_select_dialog.cc',
        'nsm.cc',
        'nsmclient.cc',
        'option_editor.cc',
        'opts.cc',
        'panner2d.cc',
        'panner_editor.cc',
        'panner_interface.cc',
        'panner_ui.cc',
        'patch_change.cc',
        'patch_change_widget.cc',
        'piano_roll_header.cc',
        'pingback.cc',
        'playlist_selector.cc',
        'plugin_display.cc',
        'plugin_eq_gui.cc',
        'plugin_pin_dialog.cc',
        'plugin_setup_dialog.cc',
        'plugin_selector.cc',
        'plugin_ui.cc',
        'port_group.cc',
        'port_insert_ui.cc',
        'port_matrix.cc',
        'port_matrix_body.cc',
        'port_matrix_column_labels.cc',
        'port_matrix_component.cc',
        'port_matrix_grid.cc',
        'port_matrix_labels.cc',
        'port_matrix_row_labels.cc',
        'processor_box.cc',
        'processor_selection.cc',
        'patch_change_dialog.cc',
        'progress_reporter.cc',
        'public_editor.cc',
        'quantize_dialog.cc',
        'rc_option_editor.cc',
        'region_editor.cc',
        'region_gain_line.cc',
        'region_layering_order_editor.cc',
        'region_selection.cc',
        'region_view.cc',
        'return_ui.cc',
        'rhythm_ferret.cc',
        'route_group_dialog.cc',
        'route_group_menu.cc',
        'route_params_ui.cc',
        'route_processor_selection.cc',
        'route_time_axis.cc',
        'route_ui.cc',
        'ruler_dialog.cc',
        'save_as_dialog.cc',
        'save_template_dialog.cc',
        'search_path_option.cc',
        'script_selector.cc',
        'selection.cc',
        'selection_memento.cc',
        'send_ui.cc',
        'session_archive_dialog.cc',
        'session_dialog.cc',
        'session_import_dialog.cc',
        'session_metadata_dialog.cc',
        'session_option_editor.cc',
        'sfdb_ui.cc',
        'shuttle_control.cc',
        'soundcloud_export_selector.cc',
        'splash.cc',
        'speaker_dialog.cc',
        'startup.cc',
        'step_editor.cc',
        'step_entry.cc',
        'stereo_panner.cc',
        'stereo_panner_editor.cc',
        'streamview.cc',
        'strip_silence_dialog.cc',
        'stripable_colorpicker.cc',
        'stripable_time_axis.cc',
        'sys_ex.cc',
        'tape_region_view.cc',
        'template_dialog.cc',
        'tempo_curve.cc',
        'tempo_dialog.cc',
        'tempo_lines.cc',
        'time_axis_view.cc',
        'time_axis_view_item.cc',
        'time_fx_dialog.cc',
        'time_info_box.cc',
        'time_selection.cc',
        'timers.cc',
        'track_selection.cc',
        'track_view_list.cc',
        'transform_dialog.cc',
        'transpose_dialog.cc',
        'ui_config.cc',
        'utils.cc',
        'vca_master_strip.cc',
        'verbose_cursor.cc',
        'visibility_group.cc',
        'window_manager.cc',
# video-timeline related sources:
        'video_image_frame.cc',
        'add_video_dialog.cc',
        'editor_videotimeline.cc',
        'vca_time_axis.cc',
        'video_timeline.cc',
        'video_monitor.cc',
        'transcode_ffmpeg.cc',
        'transcode_video_dialog.cc',
        'video_server_dialog.cc',
        'utils_videotl.cc',
        'export_video_dialog.cc',
        'export_video_infobox.cc',
        'video_tool_paths.cc'
]

def enoify (major, minor):
    # Code names based on
    # https://en.wikipedia.org/wiki/Brian_Eno_discography
    #
    # sort Studio albums + Collaborative albums + Compilation albums by Month/Year.
    # (no Singles, no EPs, no Video Albums, no Production)
    if major == 3:
        return "\\n\\\"E-No\\\""
    elif major == 4:
        if minor == 0:
            return "\\n\\\"No Pussyfooting\\\""
        elif minor == 1:
            return "\\n\\\"Here Come the Warm Jets\\\""
        elif minor == 2:
            return "\\n\\\"Taking Tiger Mountain\\\""
        elif minor == 3:
            return "\\n\\\"Lady June's Linguistic Leprosy\\\""
        elif minor == 4:
            return "\\n\\\"Discreet Music\\\""
        elif minor == 5:
            return "\\n\\\"Another Green World\\\""
        elif minor == 6:
            return "\\n\\\"Evening Star\\\""
        elif minor == 7:
            return "\\n\\\"Cluster and Eno\\\""
    elif major == 5:
        if minor == 0:
            return "\\n\\\"Before and After Science\\\""
        elif minor == 1:
            return "\\n\\\"After the Heat\\\""
        elif minor == 2:
            return "\\n\\\"Music for Airports\\\""
        elif minor == 3:
            return "\\n\\\"Music for Films\\\""
        elif minor == 4:
            return "\\n\\\"In a Land of Clear Colours\\\""
        elif minor == 5:
            return "\\n\\\"The Plateaux of Mirror\\\""
        elif minor == 6:
            return "\\n\\\"Possible Musics\\\"" # 1980 Collaborative
        elif minor == 7:
            return "\\n\\\"My Life in the Bush of Ghosts\\\"" # 1981
        elif minor == 8:
            return "\\n\\\"Music for Airplay\\\"" # 1981 Compilation
        elif minor == 9:
            return "\\n\\\"On Land\\\"" # 1982
        elif minor == 10:  # 6.0 ??
            return "\\n\\\"Atmospheres and Soundtracks\\\"" # 1983
        elif minor == 11:
            return "\\n\\\"More Music for Films\\\"" # 1983
        elif minor == 12:
            return "\\n\\\"Working Backwards\\\"" # 1984 Compilation
        elif minor == 13:
            return "\\n\\\"The Pearl\\\"" # 1984 Collaborative
        elif minor == 14:
            return "\\n\\\"Begegnungen\\\"" # 1984 Compilation
    return "\\\"\\\""

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('misc')
    conf.load('compiler_cxx')
    autowaf.configure(conf)

    # TODO: Insert a sanity check for on OS X to ensure CoreAudio is present

    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW3F',
                      mandatory=True)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW35F',
                      atleast_version='3.3.5', mandatory=False)
    autowaf.check_pkg(conf, 'flac', uselib_store='FLAC',
                      atleast_version='1.2.1')
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD',
                      atleast_version='2.10.1')
    autowaf.check_pkg(conf, 'gtk+-2.0', uselib_store='GTK',
                      atleast_version='2.18')
    autowaf.check_pkg(conf, 'gtkmm-2.4', uselib_store='GTKMM',
                      atleast_version='2.18')
    autowaf.check_pkg(conf, 'ogg', uselib_store='OGG', atleast_version='1.1.2')
    autowaf.check_pkg(conf, 'x11', uselib_store='X11', atleast_version='1.1', mandatory=False)
    autowaf.check_pkg(conf, 'pangoft2', uselib_store='PANGOFT2', atleast_version='1.36.8', mandatory=False)
    autowaf.check_pkg(conf, 'fontconfig', uselib_store='FONTCONFIG')


    if sys.platform == 'darwin':
        retval = conf.run_c_code (code='#include <AppKit/NSWindow.h>\n\
        int main(void) { (void) NSWindowWillStartLiveResizeNotification; return 0; }\n',
                                  env = conf.env.derive (),
                                  features = [ 'c' ],
                                  compiler = 'cc',

=== headless/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import shutil
import sys
import re
import time
from waflib.Task import Task

# Mandatory variables
top = '.'
out = 'build'

hardour_sources = [
        'load_session.cc',
        'misc.cc',
]

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('misc')
    conf.load('compiler_cxx')
    autowaf.configure(conf)


def build(bld):

    VERSION = "%s.%s" % (bld.env['MAJOR'], bld.env['MINOR'])
    if bld.is_defined('WINDOWS_VST_SUPPORT') and bld.env['build_target'] != 'mingw':
        return

    # just the normal executable version of the GTK GUI
    obj = bld (features = 'cxx c cxxprogram')
    # this program does not do the whole hidden symbols thing
    obj.cxxflags = [ '-fvisibility=default' ]
    obj.source    = hardour_sources
    obj.target = 'hardour-' + str (bld.env['VERSION'])
    obj.includes = ['.']

    # at this point, "obj" refers to either the normal native executable
    # OR the shared library built for use with wine on linux.

    obj.use      = [ 'libpbd',
                     'libardour',
                     'libardour_cp',
                     'libtimecode',
                     'libmidipp',
                     ]

    obj.defines = [
        'VERSIONSTRING="' + str(bld.env['VERSION']) + '"',
        'DATA_DIR="' + os.path.normpath(bld.env['DATADIR']) + '"',
        'CONFIG_DIR="' + os.path.normpath(bld.env['SYSCONFDIR']) + '"',
        'LOCALEDIR="' + os.path.join(os.path.normpath(bld.env['DATADIR']), 'locale') + '"',
        ]
    obj.install_path = bld.env['LIBDIR']
    obj.uselib       = 'UUID FLAC FONTCONFIG GLIBMM GTHREAD OGG CURL DL XML'
    obj.uselib       += ' FFTW3F'
    obj.uselib       += ' AUDIOUNITS OSX LO '
    obj.uselib       += ' TAGLIB '

    if sys.platform == 'darwin':
        obj.uselib += ' AUDIOUNITS OSX'
        obj.use    += ' libappleutility'
    obj.includes += ['../libs']

    if bld.env['build_target'] == 'mingw':
        if bld.env['DEBUG'] == False:
            obj.linkflags = ['-mwindows']

    if bld.is_defined('NEED_INTL'):
        obj.linkflags = ' -lintl'

    # Wrappers

    wrapper_subst_dict = {
            'INSTALL_PREFIX' : bld.env['PREFIX'],
            'LIBDIR'         : os.path.normpath(bld.env['LIBDIR']),
            'DATADIR'        : os.path.normpath(bld.env['DATADIR']),
            'CONFDIR'        : os.path.normpath(bld.env['CONFDIR']),
            'LIBS'           : 'build/libs',
            'VERSION'        : bld.env['VERSION'],
            'EXECUTABLE'     : 'build/headless/hardour-' + str(bld.env['VERSION'])
    }

    def set_subst_dict(obj, dict):
        for i in dict:
            setattr(obj, i, dict[i])

    obj              = bld(features = 'subst')
    obj.source       = 'hardev_common.sh.in'
    obj.target       = 'hardev_common_waf.sh'
    obj.chmod        = Utils.O755
    obj.dict         = wrapper_subst_dict
    set_subst_dict(obj, wrapper_subst_dict)

=== mcp/wscript ===
#!/usr/bin/python

import os

top = '.'
out = 'build'

def configure(conf):
    pass

def build(bld):
    devinfo = bld.path.ant_glob ('*.device')
    profiles = bld.path.ant_glob ('*.profile')
    bld.install_files (os.path.join(bld.env['DATADIR'], 'mcp'), devinfo)
    bld.install_files (os.path.join(bld.env['DATADIR'], 'mcp'), profiles)

def options(opt):
    pass

=== osc/wscript ===
#!/usr/bin/python

import os

top = '.'
out = 'build'

def configure(conf):
    pass

def build(bld):
    presets = bld.path.ant_glob ('*.preset')
    bld.install_files (os.path.join(bld.env['DATADIR'], 'osc'), presets)

def options(opt):
    pass

=== scripts/wscript ===
#!/usr/bin/python

import os

top = '.'
out = 'build'

def configure(conf):
    pass

def build(bld):
    scripts = bld.path.ant_glob ('*.lua', excl=['^_*'])
    bld.install_files (os.path.join(bld.env['DATADIR'], 'scripts'), scripts)

def options(opt):
    pass

=== session_utils/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import shutil
import sys
import re
import time
from waflib.Task import Task

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    if not "dummy" in conf.env['BACKENDS']:
        print ('session-utils depend on the dummy backend.')
        autowaf.display_msg(conf, 'build session-utils', 'no')
        return
    # no wine
    if Options.options.windows_vst and Options.options.dist_target != 'mingw':
        autowaf.display_msg(conf, 'build session-utils', 'no')
        return
    autowaf.display_msg(conf, 'build session-utils', 'yes')
    conf.load('misc')
    conf.load('compiler_cxx')
    autowaf.configure(conf)

def build_ardour_util(bld, util):
    pgmprefix = bld.env['PROGRAM_NAME'].lower() + str(bld.env['MAJOR'])

    # just the normal executable version of the GTK GUI
    obj = bld (features = 'cxx c cxxprogram')
    # this program does not do the whole hidden symbols thing
    obj.cxxflags = [ '-fvisibility=default' ]
    obj.source   = ['common.cc', util + '.cc' ]
    obj.target   = pgmprefix + '-' + util
    obj.includes = ['.']
    obj.use      = [ 'libpbd',
                     'libardour',
                     'libardour_cp',
                     'libtimecode',
                     'libmidipp',
                     ]
    obj.defines = [
        'VERSIONSTRING="' + str(bld.env['VERSION']) + '"',
        'UTILNAME="'   + str(pgmprefix + '-' + util) + '"',
        'DATA_DIR="'   + os.path.normpath(bld.env['DATADIR']) + '"',
        'CONFIG_DIR="' + os.path.normpath(bld.env['SYSCONFDIR']) + '"',
        'LOCALEDIR="'  + os.path.join(os.path.normpath(bld.env['DATADIR']), 'locale') + '"',
        'PACKAGE="'    + "ARDOURUTILS" + '"',
        ]
    obj.install_path = bld.env['LIBDIR'] + '/utils'
    obj.uselib       = 'UUID FLAC FONTCONFIG GLIBMM GTHREAD OGG CURL DL XML'
    obj.uselib       += ' FFTW3F'
    obj.uselib       += ' AUDIOUNITS OSX LO '
    obj.uselib       += ' TAGLIB '

    if sys.platform == 'darwin':
        obj.uselib += ' AUDIOUNITS OSX'
        obj.use    += ' libappleutility'
    obj.includes += ['../libs']

    if bld.env['build_target'] == 'mingw':
        obj.install_path = bld.env['BINDIR']

    if bld.is_defined('NEED_INTL'):
        obj.linkflags = ' -lintl'


def build(bld):
    VERSION = "%s.%s" % (bld.env['MAJOR'], bld.env['MINOR'])
    # session-utils depend on the dummy backend
    if not "dummy" in bld.env['BACKENDS']:
        return
    # no wine
    if bld.is_defined('WINDOWS_VST_SUPPORT') and bld.env['build_target'] != 'mingw':
        return

    pgmprefix = bld.env['PROGRAM_NAME'].lower() + str(bld.env['MAJOR'])

    utils = bld.path.ant_glob('*.cc', excl=['example.cc', 'common.cc'])

    for util in utils:
        fn = str(util)[:-3]
        build_ardour_util(bld, fn)
        if bld.env['build_target'] != 'mingw':
            bld.symlink_as(bld.env['BINDIR'] + '/' + pgmprefix + "-" + fn, bld.env['LIBDIR'] + '/utils/ardour-util.sh')

    if bld.env['build_target'] == 'mingw':
        return

    obj              = bld(features = 'subst')
    obj.source       = 'ardour-util.sh.in'
    obj.target       = 'ardour-util.sh'
    obj.chmod        = Utils.O755
    obj.install_path = bld.env['LIBDIR']  + '/utils'
    obj.LIBDIR       = os.path.normpath(bld.env['DLLDIR'])
    obj.DATADIR      = os.path.normpath(bld.env['DATADIR'])
    obj.CONFDIR      = os.path.normpath(bld.env['CONFDIR'])

=== libs/ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import sys
import re
import subprocess
import sys

# default state file version for this build
CURRENT_SESSION_FILE_VERSION = 3002

I18N_PACKAGE = 'ardour'

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/ardour/'

libardour_sources = [
        'amp.cc',
        'analyser.cc',
        'analysis_graph.cc',
        'async_midi_port.cc',
        'audio_backend.cc',
        'audio_buffer.cc',
        'audio_diskstream.cc',
        'audio_library.cc',
        'audio_playlist.cc',
        'audio_playlist_importer.cc',
        'audio_playlist_source.cc',
        'audio_port.cc',
        'audio_region_importer.cc',
        'audio_track.cc',
        'audio_track_importer.cc',
        'audioanalyser.cc',
        'audioengine.cc',
        'audiofile_tagger.cc',
        'audiofilesource.cc',
        'audioregion.cc',
        'audiosource.cc',
        'auditioner.cc',
        'automatable.cc',
        'automation.cc',
        'automation_control.cc',
        'automation_list.cc',
        'automation_watch.cc',
        'beats_frames_converter.cc',
        'broadcast_info.cc',
        'buffer.cc',
        'buffer_manager.cc',
        'buffer_set.cc',
        'bundle.cc',
        'butler.cc',
        'capturing_processor.cc',
        'chan_count.cc',
        'chan_mapping.cc',
        'config_text.cc',
        'controllable_descriptor.cc',
        'control_group.cc',
        'control_protocol_manager.cc',
        'cycle_timer.cc',
        'data_type.cc',
        'default_click.cc',
        'debug.cc',
        'delayline.cc',
        'delivery.cc',
        'directory_names.cc',
        'diskstream.cc',
        'dsp_filter.cc',
        'ebur128_analysis.cc',
        'element_import_handler.cc',
        'element_importer.cc',
        'engine_slave.cc',
        'enums.cc',
        'event_type_map.cc',
        'export_channel.cc',
        'export_channel_configuration.cc',
        'export_failed.cc',
        'export_filename.cc',
        'export_format_base.cc',
        'export_format_manager.cc',
        'export_format_specification.cc',
        'export_formats.cc',
        'export_graph_builder.cc',
        'export_handler.cc',
        'export_preset.cc',
        'export_profile_manager.cc',
        'export_status.cc',
        'export_timespan.cc',
        'file_source.cc',
        'filename_extensions.cc',
        'filesystem_paths.cc',
        'filter.cc',
        'find_session.cc',
        'fixed_delay.cc',
        'fluid_synth.cc',
        'gain_control.cc',
        'globals.cc',
        'graph.cc',
        'graphnode.cc',
        'iec1ppmdsp.cc',
        'iec2ppmdsp.cc',
        'import.cc',
        'instrument_info.cc',
        'internal_return.cc',
        'internal_send.cc',
        'interpolation.cc',
        'io.cc',
        'io_processor.cc',
        'kmeterdsp.cc',
        'ladspa_plugin.cc',
        'legatize.cc',
        'location.cc',
        'location_importer.cc',
        'ltc_file_reader.cc',
        'ltc_slave.cc',
        'lua_api.cc',
        'luabindings.cc',
        'luaproc.cc',
        'luascripting.cc',
        'meter.cc',
        'midi_automation_list_binder.cc',
        'midi_buffer.cc',
        'midi_channel_filter.cc',
        'midi_clock_slave.cc',
        'midi_diskstream.cc',
        'midi_model.cc',
        'midi_patch_manager.cc',
        'midi_playlist.cc',
        'midi_playlist_source.cc',
        'midi_port.cc',
        'midi_region.cc',
        'midi_ring_buffer.cc',
        'midi_scene_change.cc',
        'midi_scene_changer.cc',
        'midi_source.cc',
        'midi_state_tracker.cc',
        'midi_stretch.cc',
        'midi_track.cc',
        'midi_ui.cc',
        'mididm.cc',
        'midiport_manager.cc',
        'mix.cc',
        'mode.cc',
        'monitor_control.cc',
        'monitor_processor.cc',
        'mtc_slave.cc',
        'mtdm.cc',
        'muteable.cc',
        'mute_control.cc',
        'mute_master.cc',
        'note_fixer.cc',
        'onset_detector.cc',
        'operations.cc',
        'pan_controllable.cc',
        'pannable.cc',
        'panner.cc',
        'panner_manager.cc',
        'panner_shell.cc',
        'parameter_descriptor.cc',
        'pcm_utils.cc',
        'phase_control.cc',
        'playlist.cc',
        'playlist_factory.cc',
        'playlist_source.cc',
        'plugin.cc',
        'plugin_insert.cc',
        'plugin_manager.cc',
        'port.cc',
        'port_insert.cc',
        'port_manager.cc',
        'port_set.cc',
        'presentation_info.cc',
        'process_thread.cc',
        'processor.cc',
        'progress.cc',
        'quantize.cc',
        'rc_configuration.cc',
        'readonly_control.cc',
        'recent_sessions.cc',
        'record_enable_control.cc',
        'record_safe_control.cc',
        'region_factory.cc',
        'resampled_source.cc',
        'region.cc',
        'return.cc',
        'reverse.cc',
        'route.cc',
        'route_graph.cc',
        'route_group.cc',
        'route_group_member.cc',
        'rb_effect.cc',
        'scene_change.cc',
        'search_paths.cc',
        'selection.cc',
        'send.cc',
        'session.cc',
        'session_butler.cc',
        'session_click.cc',
        'session_command.cc',
        'session_configuration.cc',
        'session_directory.cc',
        'session_events.cc',
        'session_export.cc',
        'session_handle.cc',
        'session_ltc.cc',
        'session_metadata.cc',
        'session_midi.cc',
        'session_object.cc',
        'session_playlists.cc',
        'session_process.cc',
        'session_rtevents.cc',
        'session_state.cc',
        'session_state_utils.cc',
        'session_time.cc',
        'session_transport.cc',
        'sidechain.cc',
        'slave.cc',
        'slavable.cc',
        'slavable_automation_control.cc',
        'smf_source.cc',
        'sndfile_helpers.cc',
        'sndfileimportable.cc',
        'sndfilesource.cc',
        'solo_control.cc',
        'solo_isolate_control.cc',
        'solo_safe_control.cc',
        'soundcloud_upload.cc',
        'source.cc',
        'source_factory.cc',
        'speakers.cc',
        'srcfilesource.cc',
        'stripable.cc',
        'strip_silence.cc',
        'system_exec.cc',
        'revision.cc',
        'tape_file_matcher.cc',
        'template_utils.cc',
        'tempo.cc',
        'tempo_map_importer.cc',
        'thread_buffers.cc',
        'ticker.cc',
        'track.cc',
        'transient_detector.cc',
        'transform.cc',
        'transpose.cc',
        'unknown_processor.cc',
        'user_bundle.cc',
        'utils.cc',
        'vca.cc',
        'vca_manager.cc',
        'vumeterdsp.cc',
        'worker.cc'
]

def flac_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.flac",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def ogg_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.ogg",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    conf.load('gas')
    # we don't use hard-coded micro versions with ardour, so hard code it to zero
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                      atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO4',
                      atleast_version='0.4.0', mandatory=False)
    autowaf.check_pkg(conf, 'libxml-2.0', uselib_store='XML')
    if Options.options.dist_target != 'mingw':
        if not Options.options.no_lrdf:
            autowaf.check_pkg(conf, 'lrdf', uselib_store='LRDF',
                              atleast_version='0.4.0')
        autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                          atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'samplerate', uselib_store='SAMPLERATE',
                      atleast_version='0.1.0')
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP',
                      atleast_version='2.0')

    if Options.options.lv2:
        autowaf.check_pkg(conf, 'lv2', uselib_store='LV2',
                          atleast_version='1.0.0', mandatory=True)
        autowaf.check_pkg(conf, 'lv2', uselib_store='LV2_1_2_0',
                          atleast_version='1.2.0', mandatory=False)
        autowaf.check_pkg(conf, 'lv2', uselib_store='LV2_1_10_0',
                          atleast_version='1.10.0', mandatory=False)
        autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
                          atleast_version='0.14.0', mandatory=True)
        autowaf.check_pkg(conf, 'sord-0', uselib_store='SORD',
                          atleast_version='0.8.0', mandatory=True)
        autowaf.check_pkg(conf, 'sratom-0', uselib_store='SRATOM',
                          atleast_version='0.2.0', mandatory=True)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV',
                          atleast_version='0.14.0', mandatory=True)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV_0_16_0',
                          atleast_version='0.16.0', mandatory=False)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV_0_19_2',
                          atleast_version='0.19.2', mandatory=False)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV_0_21_3',
                          atleast_version='0.21.3', mandatory=False)
        autowaf.check_pkg(conf, 'suil-0', uselib_store='SUIL',
                          atleast_version='0.6.0', mandatory=False)
        conf.define ('LV2_SUPPORT', 1)

    # non-standard LV2 extention -- TODO: add option to disable??
    if conf.is_defined ('HAVE_LV2_1_10_0'):
        conf.define ('LV2_EXTENDED', 1)

#    autowaf.check_pkg(conf, 'soundtouch-1.0', uselib_store='SOUNDTOUCH',
#                      mandatory=False)
    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT',
                      atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'ogg', uselib_store='OGG', atleast_version='1.1.2')
    autowaf.check_pkg(conf, 'flac', uselib_store='FLAC',
                      atleast_version='1.2.1')
    autowaf.check_pkg(conf, 'libcurl', uselib_store='CURL',
                      atleast_version='7.0.0')

    # controls whether we actually use it in preference to soundtouch
    # Note: as of 2104, soundtouch (WSOLA) has been out-of-use for years.
    conf.define('USE_RUBBERBAND', 1)

    conf.define('CURRENT_SESSION_FILE_VERSION', CURRENT_SESSION_FILE_VERSION)

    conf.check(header_name='sys/vfs.h', define_name='HAVE_SYS_VFS_H',mandatory=False)
    conf.check(header_name='sys/statvfs.h', define_name='HAVE_SYS_STATVFS_H',mandatory=False)

    conf.check(header_name='unistd.h', define_name='HAVE_UNISTD',mandatory=False)

    if flac_supported():
        conf.define ('HAVE_FLAC', 1)
    if ogg_supported():
        conf.define ('HAVE_OGG', 1)

    conf.write_config_header('libardour-config.h', remove=False)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/scoped_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/ptr_container/ptr_list.hpp')
    if conf.env['WINDOWS_VST_SUPPORT'] == True and Options.options.dist_target == 'mingw':
        conf.check(compiler='cxx',
                   lib='gdi32',
                   mandatory=True,
                   uselib_store='GDI32')


def build(bld):

=== libs/audiographer/wscript ===
#!/usr/bin/env python
# -*- coding: utf-8 -*-
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
AUDIOGRAPHER_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Version history:
#   0.0.0 = 0,0,0
AUDIOGRAPHER_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'audiographer'
VERSION = AUDIOGRAPHER_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)

    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT', atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP', atleast_version='2.0', mandatory=False)
    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB', atleast_version='2.2', mandatory=False)
    autowaf.check_pkg(conf, 'glibmm-2.4', uselib_store='GLIBMM', atleast_version='2.14.0', mandatory=False)
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD', atleast_version='2.14.0', mandatory=False)
    autowaf.check_pkg(conf, 'samplerate', uselib_store='SAMPLERATE', atleast_version='0.1.7', mandatory=False)
    autowaf.check_pkg(conf, 'sndfile', uselib_store='SNDFILE', atleast_version='1.0.18', mandatory=False)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW3F', mandatory=True)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW35F', atleast_version='3.3.5', mandatory=False)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/format.hpp')

def build(bld):

    # Headers
    #bld.install_files('${INCLUDEDIR}/audiographer', bld.path.ant_glob('audiographer/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/general', bld.path.ant_glob('audiographer/general/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/sndfile', bld.path.ant_glob('audiographer/sndfile/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/utils', bld.path.ant_glob('audiographer/utils/*.h'))

    #bld.env['BUILD_TESTS'] = True
    bld.env['HAVE_ALL_GTHREAD'] = (bld.is_defined('HAVE_GLIB')
                                   and bld.is_defined('HAVE_GLIBMM')
                                   and bld.is_defined('HAVE_GTHREAD'))

    if bld.is_defined('HAVE_FFTW35F') and bld.env['build_target'] != 'mingw':
        bld.env['LIB_FFTW3F'] += ['fftw3f_threads']

    audiographer_sources = [
        'private/gdither/gdither.cc',
        'src/general/sample_format_converter.cc',
        'src/routines.cc',
        'src/debug_utils.cc',
        'src/general/analyser.cc',
        'src/general/broadcast_info.cc',
        'src/general/loudness_reader.cc',
        'src/general/normalizer.cc'
        ]
    if bld.is_defined('HAVE_SAMPLERATE'):
        audiographer_sources += [ 'src/general/sr_converter.cc' ]

    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        audiographer              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=audiographer_sources)
        # macros for this shared library
        audiographer.defines      = [ 'LIBAUDIOGRAPHER_DLL_EXPORTS=1' ]
    else:
        audiographer              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=audiographer_sources)
        audiographer.cxxflags     = [ '-fPIC' ]
        audiographer.cflags       = [ '-fPIC' ]
        audiographer.defines      = []

    audiographer.name           = 'libaudiographer'
    audiographer.target         = 'audiographer'
    audiographer.export_includes = ['.', './src']
    audiographer.includes       = ['.', './src','../ardour','../timecode','../evoral']
    audiographer.uselib         = 'GLIB GLIBMM GTHREAD SAMPLERATE SNDFILE FFTW3F VAMPSDK VAMPHOSTSDK XML'
    audiographer.use            = 'libpbd'
    audiographer.vnum           = AUDIOGRAPHER_LIB_VERSION
    audiographer.install_path   = bld.env['LIBDIR']


    if bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
        # Unit tests
        obj              = bld(features = 'cxx cxxprogram')
        obj.source       = '''
                tests/test_runner.cc
                tests/type_utils_test.cc
                tests/utils/identity_vertex_test.cc
                tests/general/interleaver_test.cc
                tests/general/deinterleaver_test.cc
                tests/general/interleaver_deinterleaver_test.cc
                tests/general/chunker_test.cc
                tests/general/sample_format_converter_test.cc
                tests/general/peak_reader_test.cc
                tests/general/normalizer_test.cc
                tests/general/silence_trimmer_test.cc
        '''

        if bld.is_defined('HAVE_ALL_GTHREAD'):
            obj.source += '''
                    tests/general/threader_test.cc
            '''

        if bld.is_defined('HAVE_SNDFILE'):
            obj.source += '''
                    tests/sndfile/tmp_file_test.cc
            '''

        if bld.is_defined('HAVE_SAMPLERATE'):
            obj.source += '''
                    tests/general/sr_converter_test.cc
            '''

        obj.use          = 'libaudiographer'
        obj.uselib       = 'CPPUNIT GLIBMM SAMPLERATE SNDFILE FFTW3F VAMPSDK VAMPHOSTSDK'
        obj.target       = 'run-tests'
        obj.install_path = ''

def shutdown():
    autowaf.shutdown()

=== libs/canvas/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
from waflib import TaskGen
import os

# Version of this package (even if built as a child)
MAJOR = '0'
MINOR = '0'
MICRO = '0'
CANVAS_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
CANVAS_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'canvas'
VERSION = CANVAS_VERSION
I18N_PACKAGE = 'libcanvas'

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/canvas/'

canvas_sources = [
        'arc.cc',
        'arrow.cc',
        'box.cc',
        'canvas.cc',
        'circle.cc',
        'container.cc',
        'curve.cc',
        'debug.cc',
        'item.cc',
        'fill.cc',
        'flag.cc',
        'framed_curve.cc',
        'grid.cc',
        'image.cc',
        'line.cc',
        'line_set.cc',
        'lookup_table.cc',
        'meter.cc',
        'outline.cc',
        'pixbuf.cc',
        'poly_item.cc',
        'poly_line.cc',
        'polygon.cc',
        'rectangle.cc',
        'root_group.cc',
        'ruler.cc',
        'scroll_group.cc',
        'stateful_image.cc',
        'text.cc',
        'tracking_text.cc',
        'types.cc',
        'utils.cc',
        'widget.cc',
        'xfade_curve.cc',
]

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load ('compiler_cxx')
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'cairomm-1.0', uselib_store='CAIROMM', atleast_version='1.8.4')

def build(bld):
    # Library
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj = bld.shlib(features = 'cxx cxxshlib', source=canvas_sources)
        obj.defines      = [ 'LIBCANVAS_DLL_EXPORTS=1' ]
    else:
        obj = bld.stlib(features = 'cxx cxxstlib', source=canvas_sources)
        obj.cxxflags     = [ '-fPIC' ]
        obj.cflags       = [ '-fPIC' ]
        obj.defines      = [ ]

    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.uselib       = 'SIGCPP CAIROMM GTKMM BOOST XML'
    obj.use          = [ 'libpbd', 'libgtkmm2ext' ]
    obj.name         = 'libcanvas'
    obj.target       = 'canvas'
    obj.vnum         = CANVAS_LIB_VERSION
    obj.install_path = bld.env['LIBDIR']
    obj.defines      += [ 'PACKAGE="' + I18N_PACKAGE + '"' ]

    # canvas unit-tests are outdated
    if False and bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
            unit_testobj              = bld(features = 'cxx cxxprogram')
            unit_testobj.source       = '''
                    test/group.cc
                    test/arrow.cc
                    test/optimizing_lookup_table.cc
                    test/polygon.cc
                    test/types.cc
                    test/render.cc
                    test/xml.cc
                    test/wave_view.cc
                    test/item.cc
                    test/testrunner.cpp
                '''.split()

            unit_testobj.includes     = obj.includes + ['test', '../pbd']
            unit_testobj.uselib       = 'CPPUNIT SIGCPP CAIROMM GTKMM'
            unit_testobj.uselib_local = 'libcanvas libgtkmm2ext'
            unit_testobj.name         = 'libcanvas-unit-tests'
            unit_testobj.target       = 'run-tests'
            unit_testobj.install_path = ''
            unit_testobj.cxxflags     = ['-DPACKAGE="libcanvastest"']
            unit_testobj.cxxflags     += ['-DDATA_DIR="' + os.path.normpath(bld.env['DATADIR']) + '"']
            unit_testobj.cxxflags     += ['-DCONFIG_DIR="' + os.path.normpath(bld.env['CONFDIR']) + '"']
            unit_testobj.cxxflags     += ['-DMODULE_DIR="' + os.path.normpath(bld.env['LIBDIR']) + '"']

            manual_tests              = '''
                        test/hello_world.cc
                        test/gtk_many.cc
                        test/gtk_scene.cc
                        test/gtk_movement.cc
                        test/gtk_viewport.cc
                        test/gtk_drag.cc
                '''.split()

            for t in manual_tests:
                    target = t[:-3]
                    name = t[t.find('/')+1:-3]
                    manual_testobj = bld(features = 'cxx cxxprogram')
                    manual_testobj.source = t
                    manual_testobj.includes = obj.includes + ['test', '../pbd']
                    manual_testobj.uselib       = 'CPPUNIT SIGCPP CAIROMM GTKMM'
                    manual_testobj.uselib_local = 'libcanvas libgtkmm2ext'
                    manual_testobj.name         = 'libcanvas-manual-test-%s' % name
                    manual_testobj.target       = target
                    manual_testobj.install_path = ''

            benchmarks = '''
                        benchmark/items_at_point.cc
                        benchmark/render_parts.cc
                        benchmark/render_from_log.cc
                        benchmark/render_whole.cc
                '''.split()

            for t in benchmarks:
                    target = t[:-3]
                    name = t[t.find('/')+1:-3]
                    manual_testobj = bld(features = 'cxx cxxprogram')
                    manual_testobj.source = [ t, 'benchmark/benchmark.cc' ]
                    manual_testobj.includes = obj.includes + ['test', '../pbd']
                    manual_testobj.uselib       = 'CPPUNIT SIGCPP CAIROMM GTKMM'
                    manual_testobj.uselib_local = 'libcanvas libgtkmm2ext'
                    manual_testobj.name         = 'libcanvas-benchmark-%s' % name
                    manual_testobj.target       = target
                    manual_testobj.install_path = ''

def shutdown():
    autowaf.shutdown()

=== libs/evoral/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os

# Version of this package (even if built as a child)
EVORAL_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Version history:
#   0.0.0 = 0,0,0
EVORAL_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'evoral'
VERSION = EVORAL_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    opt.load('compiler_c')
    opt.load('compiler_cxx')
    autowaf.set_options(opt)
    opt.add_option('--test', action='store_true', default=False, dest='build_tests',
                    help="Build unit tests")
    opt.add_option('--test-coverage', action='store_true', default=False, dest='test_coverage',
                    help="Use gcov to test for code coverage")
    opt.add_option('--internal-shared-libs', action='store_true', default=True, dest='internal_shared_libs',
                   help='Build internal libs as shared libraries')

def configure(conf):
    conf.load('compiler_c')
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    #autowaf.display_header('Evoral Configuration')

    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT', atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB', atleast_version='2.2')
    autowaf.check_pkg(conf, 'glibmm-2.4', uselib_store='GLIBMM', atleast_version='2.14.0')
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD', atleast_version='2.14.0')
    if not autowaf.is_child():
        autowaf.check_pkg(conf, 'libpbd-4', uselib_store='LIBPBD', atleast_version='4.0.0', mandatory=True)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')

    conf.env['BUILD_TESTS'] = Options.options.build_tests
    conf.env['TEST_COVERAGE'] = Options.options.test_coverage

    if Options.options.internal_shared_libs:
        conf.define('INTERNAL_SHARED_LIBS', 1)
    #autowaf.display_msg(conf, "Unit tests", str(conf.env['BUILD_TESTS']))
    #print

def build(bld):
    # Headers
    #bld.install_files('${INCLUDEDIR}/evoral', 'evoral/*.h')
    #bld.install_files('${INCLUDEDIR}/evoral', 'evoral/*.hpp')

    # Pkgconfig file
    #autowaf.build_pc(bld, 'EVORAL', EVORAL_VERSION, 'GLIBMM GTHREAD')

    libsmf = bld(features = 'c cstlib')
    libsmf.source = '''
            src/libsmf/smf.c
            src/libsmf/smf_decode.c
            src/libsmf/smf_load.c
            src/libsmf/smf_save.c
            src/libsmf/smf_tempo.c
    '''
    libsmf.export_includes = ['./src/libsmf']
    libsmf.defines      = ['SMF_VERSION="1.2"', 'LIBSMF_DLL_EXPORTS']
    libsmf.includes     = ['./src']
    libsmf.name         = 'libsmf'
    libsmf.target       = 'smf'
    libsmf.uselib       = 'GLIB'
    libsmf.install_path = None
    if bld.env['build_target'] != 'mingw':
        libsmf.cxxflags     = [ '-fPIC' ]
        libsmf.cflags       = [ '-fPIC' ]

    lib_source = '''
            src/Control.cpp
            src/ControlList.cpp
            src/ControlSet.cpp
            src/Curve.cpp
            src/Event.cpp
            src/Note.cpp
            src/SMF.cpp
            src/Sequence.cpp
            src/TimeConverter.cpp
            src/debug.cpp
            src/types.cpp
    '''

    # Library
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=lib_source)
        # DLL exports for this library
        obj.defines      = [ 'LIBEVORAL_DLL_EXPORTS' ]
    else:
        obj              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=lib_source)
        obj.cxxflags     = [ '-fPIC' ]
        obj.cflags       = [ '-fPIC' ]
        obj.defines      = [ ]

    obj.export_includes = ['.']
    obj.includes       = ['.', './src']
    obj.name           = 'libevoral'
    obj.target         = 'evoral'
    obj.uselib         = 'GLIBMM GTHREAD SMF XML LIBPBD'
    obj.use            = 'libsmf libpbd'
    obj.vnum           = EVORAL_LIB_VERSION
    obj.install_path   = bld.env['LIBDIR']
    obj.defines       += [ 'PACKAGE="libevoral"' ]

    if bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
        # Static library (for unit test code coverage)
        obj = bld(features = 'cxx cstlib')
        obj.source         = lib_source
        obj.export_includes = ['.']
        obj.includes       = ['.', './src']
        obj.name           = 'libevoral_static'
        obj.target         = 'evoral_static'
        obj.uselib         = 'GLIBMM GTHREAD SMF XML LIBPBD'
        obj.use            = 'libsmf libpbd'
        obj.vnum           = EVORAL_LIB_VERSION
        obj.install_path   = ''
        if bld.env['TEST_COVERAGE']:
            obj.linkflags      = ['--coverage']
            obj.cflags         = ['--coverage']
            obj.cxxflags       = ['--coverage']
        obj.defines        = ['PACKAGE="libevoral"']

        # Unit tests
        obj              = bld(features = 'cxx cxxprogram')
        obj.source       = '''
                test/SequenceTest.cpp
                test/SMFTest.cpp
                test/RangeTest.cpp
                test/NoteTest.cpp
                test/CurveTest.cpp
                test/testrunner.cpp
        '''
        obj.includes     = ['.', './src']
        obj.use          = 'libevoral_static'
        obj.uselib       = 'CPPUNIT SNDFILE LIBPBD'
        obj.target       = 'run-tests'
        obj.name         = 'libevoral-tests'
        obj.install_path = ''
        obj.defines      = ['PACKAGE="libevoraltest"']
        if bld.env['TEST_COVERAGE']:
            obj.linkflags      = ['--coverage']
            obj.cflags         = ['--coverage']
            obj.cxxflags       = ['--coverage']

def test(ctx):
    autowaf.pre_test(ctx, APPNAME)
    print(os.getcwd())
    os.environ['EVORAL_TEST_PATH'] = os.path.abspath('../test/testdata/')
    autowaf.run_tests(ctx, APPNAME, ['./run-tests'])
    autowaf.post_test(ctx, APPNAME)

=== libs/fluidsynth/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import TaskGen
import os
import sys

# Version of this package (even if built as a child)
MAJOR = '1'
MINOR = '1'
MICRO = '6'
LIBFLUIDSYNTH_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Variables for 'waf dist'
APPNAME = 'libltc'
VERSION = LIBFLUIDSYNTH_VERSION
I18N_PACKAGE = 'libfluidsynth'

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    if conf.is_defined('USE_EXTERNAL_LIBS'):
        autowaf.check_pkg(conf, 'fluidsynth', uselib_store='LIBFLUIDSYNTH', atleast_version=LIBFLUIDSYNTH_VERSION, mandatory=True)
    else:
        conf.load('compiler_c')
        autowaf.configure(conf)

def build(bld):
    if bld.is_defined('USE_EXTERNAL_LIBS'):
        return
    bld (export_includes = ['fluidsynth'],
         name = 'libfluidsynth_includes'
         )
    obj = bld.stlib (source = [
        'src/fluid_midi.c',
        'src/fluid_adsr_env.c',
        'src/fluid_chorus.c',
        'src/fluid_iir_filter.c',
        'src/fluid_lfo.c',
        'src/fluid_rev.c',
        'src/fluid_rvoice.c',
        'src/fluid_rvoice_dsp.c',
        'src/fluid_rvoice_event.c',
        'src/fluid_rvoice_mixer.c',
        'src/fluid_defsfont.c',
        'src/fluid_chan.c',
        'src/fluid_event.c',
        'src/fluid_gen.c',
        'src/fluid_mod.c',
        'src/fluid_synth.c',
        'src/fluid_tuning.c',
        'src/fluid_voice.c',
        'src/fluid_conv.c',
        'src/fluid_hash.c',
        'src/fluid_list.c',
        'src/fluid_ringbuffer.c',
        'src/fluid_settings.c',
        'src/fluid_sys.c'
        ],
        cflags = [ '-fPIC', '-fvisibility=hidden' ],
        includes = ['.', 'src/' ],
               target = 'libfluidsynth',
               use    = 'libfluidsynth_includes',
               uselib = 'GLIB',
               defines = [ 'HAVE_CONFIG_H', 'DEFAULT_SOUNDFONT=""' ]
               )

    # wine-gcc hacks:
    # defining __MINGW32__ for wine-gcc is a workaround for fluidsynth's include
    # strategy (which is made for mingw or windows) without it
    # winsock2.h will complain about undeclared "u_short"
    # we also need to explicitly define  _WIN32
    if bld.is_defined('WINDOWS_VST_SUPPORT') and not bld.env['build_target'] == 'mingw':
        obj.defines += [ '_WIN32', '__MINGW32__' ]

def shutdown():
    autowaf.shutdown()

=== debian/changelog ===
ardour (1:5.12.0-3~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 10 Mar 2019 16:24:01 -0700

ardour (1:5.12.0-3) unstable; urgency=medium

  [ Jaromír Mikeš ]
  * Remove trailing whitespace from changelog.

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ IOhannes m zmölnig ]
  * Updated reproducible build (Closes: #891290)
  * Updated maintainer address
  * Fixed more spelling errors
  * Dropped unused vars from d/rules
  * Updated d/copyright
  * Regenerated d/control - really dropping transitional packages
  * Updated Vcs-* stanzas to salsa.d.o
  * Bumped standards to 4.1.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 28 Feb 2018 19:55:26 +0100

ardour (1:5.12.0-2) unstable; urgency=medium

  [ IOhannes m zmölnig ]
  * Dropped transitional packages

  [ Jaromír Mikeš ]
  * Add build reproducible patch. (Closes: #881872)
  * Bump Standards.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 16 Nov 2017 09:20:09 +0100

ardour (1:5.12.0-1) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * Improve maintainer script copyright-check:
    + Check flac and xcf files.
    + Fix skip icns and wav files.
    + Skip specific zip-compressed xml file.
  * Update copyright info:
    + Fix track forked code copy of libsmf, licensed as BSD-3-clause.
    + Fix expand coverage of code copy of libltc.
    + Fix code copy of pbd: license is LGPL-2.1+.
    + Merge some Files sections.
    + Tighten Files section for evoral library, and quote License-Grant.
    + Add missing copyright holders for an evoral library file.
    + Add missing copyright holder for hidapi library.
    + Add missing copyright holder for chromagram/ConstantQ files.

  [ Jaromír Mikeš ]
  * New upstream version 5.12.0
  * Update copyright_hints file.
  * Bump Standards.
  * Patches refreshed.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 02 Oct 2017 15:36:32 +0200

=== debian/control ===
Source: ardour
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 cdbs,
 debhelper (>= 10~),
 dh-buildinfo,
 gettext,
 intltool,
 itstool,
 libarchive-dev (>= 3.0.0),
 libboost-dev (>= 1.49.0),
 libcurl4-gnutls-dev (>= 7.25.0),
 libfftw3-dev (>= 3.3.1),
 liblrdf0-dev (>= 0.4.0),
 libserd-dev (>= 0.18.2~),
 libsord-dev (>= 0.12.0~),
 libsuil-dev (>= 0.6.10~),
 liblilv-dev,
 libsratom-dev (>= 0.4.2~),
 libsigc++-2.0-dev (>= 2.2.10),
 uuid-dev,
 libxml2-dev (>= 2.5.7),
 libcwiid-dev [linux-any],
 libcairomm-1.0-dev (>= 1.10.0),
 libgtkmm-2.4-dev (>= 2.24.2),
 libpangomm-1.4-dev (>= 2.28.4),
 libhidapi-dev,
 libusb-1.0-0-dev,
 ladspa-sdk (>= 1.1-2),
 libasound2-dev (>= 0.9.4) [linux-any],
 libaubio-dev (>= 0.3.2),
 libfluidsynth-dev,
 libjack-dev,
 liblo-dev (>= 0.26~),
 libltc-dev,
 libqm-dsp-dev,
 librubberband-dev,
 libsamplerate0-dev (>= 0.1.8),
 libsndfile1-dev (>= 1.0.25),
 libtag1-dev,
 lv2-dev (>= 1.2.0),
 vamp-plugin-sdk (>=2.1),
 python-setuptools,
 python-isodate,
 python-rdflib
Standards-Version: 4.1.3
Homepage: http://www.ardour.org/
Vcs-Git: https://salsa.debian.org/multimedia-team/ardour.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/ardour

Package: ardour
Architecture: any
Depends:
 ardour-data (>= ${source:Version}), ardour-data (<< ${source:Upstream-Version}.0~),
 ${cdbs:Depends},
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
 ardour-video-timeline,
 ${cdbs:Recommends},
Suggests:
 ${cdbs:Suggests},
 ${shlibs:Suggests},
Conflicts:
 ${cdbs:Conflicts},
Replaces:
 ardour3 (<< 1:3.5),
 ${cdbs:Replaces},
Breaks:
 ardour3 (<< 1:3.5),
Description: the digital audio workstation
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 Ardour supports pro-audio interfaces
 through the ALSA project, which provides high quality, well designed
 device drivers and API's for audio I/O under Linux. Any interface
 supported by ALSA can be used with Ardour. This includes the
 all-digital 26 channel RME Hammerfall, the Midiman Delta 1010 and many
 others.
 .
 Ardour has support for 24 bit samples
 using floating point internally, non-linear editing with unlimited undo,
 a user-configurable mixer, MTC master/slave capabilities, MIDI hardware
 control surface compatibility.
 .
 It supports MIDI
 Machine Control, and so can be controlled from any MMC controller and
 many modern digital mixers.
 .
 Ardour contains a
 powerful multitrack audio editor/arranger that is completely
 non-destructive and capable of all standard non-linear editing
 operations (insert, replace, delete, move, trim, select,
 cut/copy/paste). The editor has unlimited undo/redo capabilities and can
 save independent "versions" of a track or an entire piece
 .
 Ardour's editor supports the community-developed LADSPA
 plugin standard.  Arbitrary chains of plugins can be attached to any
 portion of a track.  Every mixer strip can have any number of inputs
 and outputs, not just mono, stereo or 5.1.  An N-way panner is
 included, with support for various panning models.  Pre- and post-fader
 sends exist, each with their own gain and pan controls.  Every mixer
 strip acts as its own bus, and thus the bus count in Ardour is
 unlimited.  You can submix any number of strips into another
 strip.
 .
 Ardour's channel capacity is limited only
 by the number on your audio interface and the ability of your disk
 subsystem to stream the data back and forth.
 .
 JACK
 (the JACK Audio Connection Kit) is used for all audio I/O, permitting
 data to be exchanged in perfect samplesync with other applications
 and/or hardware audio interfaces.
 .
 Ardour is
 sample rate and size neutral - any hardware formats from 8 to 32 bits,
 and rates from 8kHz to 192kHz.  Internal processing in 32/64 bit IEEE
 floating point format.
 .
 Further information can be
 found at <http://ardour.org/>.

Package: ardour-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: ardour
Breaks: ardour (<= 1:4.2~dfsg-1),
 ardour3 (<< 1:3.5),
Replaces: ardour (<= 1:4.2~dfsg-1),
 ardour3 (<< 1:3.5),
Description: digital audio workstation (data)
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This package contains the architecture-independent data files.

Package: ardour-video-timeline
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
 xjadeo (>= 0.6.4),
 harvid (>= 0.7.0),
 ffmpeg (>= 7:1.2),
Description: digital audio workstation - video timeline
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This is a dependency package to add video timeline capabilities to ardour.

=== debian/rules ===
#!/usr/bin/make -f
#
# Robert Jordens <jordens@debian.org>
#
# This software may be used and distributed according to the terms
# of the GNU General Public License, incorporated herein by reference.

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

-include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

DEB_CLEAN_EXCLUDE=debian/tmp
DEB_DESTDIR = $(CURDIR)/debian/tmp/

# Set tag to full 40 char git tag for git snapshot release
tag = $(DEB_UPSTREAM_TARBALL_VERSION)
DEB_UPSTREAM_URL = https://github.com/Ardour/ardour/archive
DEB_UPSTREAM_TARBALL_BASENAME = $(tag)
DEB_UPSTREAM_TARBALL_SRCDIR = ardour-$(tag)

# Exclude these files from the Debian version
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./waf
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./.git*
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./MSVCvst_scan
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./MSVCardour3
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./icons/win32/resource
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./icons/win32/msvc_resources.rc.in
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./gtk2_ardour/win32/*

waf-configure-options = --lv2 \
	--lxvst \
	--freedesktop \
	--configdir=/etc/ \
	--noconfirm \
	--prefix=/usr/ \
	--no-phone-home \
	--use-external-libs \
	--optimize \
	--cxx11 \
	$(empty)


DIST_TARGET = none
ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	DIST_TARGET = i686
endif
ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	DIST_TARGET = x86_64
endif

BACKENDS = jack,dummy
ifneq (,$(findstring linux,$(DEB_HOST_ARCH_OS)))
	# ALSA Backend is only available on Linux
	BACKENDS = jack,alsa,dummy
else
	waf-configure-options += \
		--no-fpu-optimization \
		$(empty)
endif

LD_LIBRARY_PATH += :$(DEB_DESTDIR)/usr/lib/ardour5/

waf-configure-options += \
	--with-backends=$(BACKENDS) \
	--dist-target=$(DIST_TARGET) \
	$(empty)

DEB_MAKE_EXTRA_ARGS = -v --destdir=$(CURDIR)/debian/tmp
DEB_MAKE_BUILD_TARGET = build i18n_mo
DEB_MAKE_ENVVARS = CFLAGS="$(or $(CFLAGS_$(cdbs_curpkg)),$(CFLAGS))" CXXFLAGS="$(or $(CXXFLAGS_$(cdbs_curpkg)),$(CXXFLAGS))" CPPFLAGS="$(or $(CPPFLAGS_$(cdbs_curpkg)),$(CPPFLAGS))" LDFLAGS="$(or $(LDFLAGS_$(cdbs_curpkg)),$(LDFLAGS))"
DEB_MAKE_INVOKE = $(DEB_MAKE_ENVVARS) $(CURDIR)/waf-light $(DEB_MAKE_EXTRA_ARGS)
DEB_MAKE_INSTALL_TARGET = install

## no dbgsym packages
DEB_DH_STRIP_ARGS := --no-automatic-dbgsym

## ardour includes a couple of private lib*.so files, which make
## dh_makeshlibs emit a useless call to `ldconfig` in the postinst script.
## since we don't have any public libraries, we just suppress that call.
DEB_DH_MAKESHLIBS_ARGS_ardour := --noscripts

clean::
	rm -f autowaf.pyc
	rm -f .lock-wscript .lock-waf_linux2_build
	find waflib -name "*.pyc" -delete || true
	find . -name "*.mo" -delete || true
	rm -rf build
	rm -f \
		gtk2_ardour/version.cc\
		gtk2_ardour/version.h\
		gtk2_ardour/ardour.appdata.xml.in\
		libs/ardour/ardour/version.h\
		libs/ardour/config_text.cc\
		libs/ardour/svn_revision.cc\
		libs/ardour/version.cc\
		libs/gtkmm2ext/gtkmm2ext/version.h\
		libs/gtkmm2ext/version.cc\
		libs/midi++2/midi++/version.h\
		libs/midi++2/version.cc\
		libs/pbd/pbd/version.h\
		libs/pbd/version.cc\
		$(empty)
	rm -rf debian/tmp


common-configure-arch common-configure-indep:: common-configure-impl
common-configure-impl:: libs/ardour/revision.cc debian/stamp-waf-configure


libs/ardour/revision.cc:
	echo '#include "ardour/revision.h"' > $@
	echo "namespace ARDOUR { const char* revision = \"${DEB_VERSION}\"; }" >> $@

debian/stamp-waf-configure:
	chmod +x ./waf-light
	$(DEB_MAKE_INVOKE) configure $(waf-configure-options)
	touch $@
clean::
	rm -f debian/stamp-waf-configure
	rm -f libs/ardour/revision.cc

# Needed at build time
# (separated in build tools, core, Glib/GTK and audio dependencies)
CDBS_BUILD_DEPENDS +=\
	, gettext\
	, intltool\
	, itstool\
	$(empty)
CDBS_BUILD_DEPENDS +=\
	, libarchive-dev (>= 3.0.0)\
	, libboost-dev (>= 1.49.0)\
	, libcurl4-gnutls-dev (>= 7.25.0)\
	, libfftw3-dev (>= 3.3.1)\
	, liblrdf0-dev (>= 0.4.0)\
	, libserd-dev (>= 0.18.2~)\
	, libsord-dev (>= 0.12.0~)\
	, libsuil-dev (>= 0.6.10~)\
	, liblilv-dev\
	, libsratom-dev (>= 0.4.2~)\
	, libsigc++-2.0-dev (>= 2.2.10)\
	, uuid-dev\
	, libxml2-dev (>= 2.5.7)\
	, libcwiid-dev [linux-any]\
	, $(empty)
CDBS_BUILD_DEPENDS +=\
	, libcairomm-1.0-dev (>= 1.10.0)\
	, libgtkmm-2.4-dev (>= 2.24.2)\
	, libpangomm-1.4-dev (>= 2.28.4)\
	, libhidapi-dev\
	, libusb-1.0-0-dev\
	, $(empty)
CDBS_BUILD_DEPENDS +=\
	, ladspa-sdk (>= 1.1-2)\
	, libasound2-dev (>= 0.9.4) [linux-any]\
	, libaubio-dev (>= 0.3.2)\
	, libfluidsynth-dev\
	, libjack-dev\
	, liblo-dev (>= 0.26~)\
	, libltc-dev\
	, libqm-dsp-dev\
	, librubberband-dev\
	, libsamplerate0-dev (>= 0.1.8)\
	, libsndfile1-dev (>= 1.0.25)\
	, libtag1-dev\
	, lv2-dev (>= 1.2.0)\
	, vamp-plugin-sdk (>=2.1)\
	, $(empty)
CDBS_BUILD_DEPENDS +=\
	, python-setuptools\
	, python-isodate\
	, python-rdflib\
	, $(empty)

# Needed always/often/sometimes at runtime
CDBS_DEPENDS_ALL = jackd
CDBS_RECOMMENDS_ALL = iceweasel | www-browser
CDBS_SUGGESTS_ALL = jamin, qjackctl

# Ensure only one variant is installed at a time
CDBS_PROVIDES_ardour-altivec = ardour
CDBS_PROVIDES_ardour-i686 = ardour

# Quirk for derivatives using different packaging name
ifeq (Ubuntu,$(shell dpkg-vendor --query Vendor))
CDBS_RECOMMENDS_ALL = firefox | www-browser
endif

DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./waf
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./.git*
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./MSVC**
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./msvc*
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./icons/win32/**
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./gtk2_ardour/win32/**

MANPAGES = ardour5-copy-mixer.1 ardour5-export.1 ardour5-fix_bbtppq.1
.PHONY: manpages manpageclean
$(MANPAGES): debian/ardour5-utils.1
	cp $^ $@
manpages: $(MANPAGES)
manpageclean:
	rm -f $(MANPAGES)

build/ardour:: manpages
clean:: manpageclean
